import fetch from 'unfetch';
import { ValidationError } from './ValidationError';
export declare abstract class Api<Endpoints extends string, Requests extends {
    [key in Endpoints]: any;
}, Responses extends {
    [key in Endpoints]: any;
}> {
    abstract baseUrl: string;
    protected fetchFunction: typeof fetch;
    call<T extends Endpoints>(endpoint: T, request: Requests[T]): Promise<Responses[T]>;
    mergeValidationErrors(validationErrors: ValidationError[]): ValidationError;
    getValidationErrorFromResponseText(responseText?: string): ValidationError | undefined;
}
